; R7 A low Byte
; R6 A high Byte
; R5 B low Byte
; R4 B high Byte

; A  C low Byte
; B  C high Byte

include REG51.inc

CSEG AT 0x0000 ;Startadresse
 	jmp _START

CSEG AT 0x0050 	
_START:
	clr a
	clr c
   jmp _ZAHLA
_ZAHLA:
   mov R7, #0x01 ; Zahl A low
	mov R6, #0xFF ; Zahl A high
	JMP _ZAHLB
_ZAHLB:
   mov R5, #0xFF ; Zahl B low
	mov R4, #0x00 ; Zahl B high
   jmp _SUBB

_ADD:
  mov A,R7  ;Zahl A low in Akku
  add A,R5  ;add  B low
  
  mov R2,A  ;hau weg die Scheie
  
  mov A,R6  ;Zahl A high in Akku
  addc A,R4 ;add  B high +carry in Akku  

  mov B,A;  ; B = Ergebnis high
  mov A,R2  ; A = Ergebnis low
  jmp _END

_SUBB:

  clr c
  mov A,R7  ;Zahl A low in Akku
  subb A,R5  ;subb  B low
  
  mov R2,A  ;hau weg die Scheie
  
  mov A,R6  ;Zahl A high in Akku
  subb A,R4 ;subb  B high in Akku  

  mov B,A;  ; B = Ergebnis high
  mov A,R2  ; A = Ergebnis low
  jmp _END




_END:
  nop
  jmp _END



	
END













